/***********************************************************************************************

Authors: Thomas K Leong, Grace H Tabada, Jingrong Yang, Zheng Zhu, Romain Neugebauer
Maintainer: Romain Neugebauer (romain.s.neugebauer@kp.org)

Copyright 2016 Thomas K Leong, Grace H Tabada, Jingrong Yang, Zheng Zhu, Romain Neugebauer

This file is part of %_MSMstructure.

%_MSMstructure is free software: you can redistribute it and/or modify it under the terms of 
the GNU General Public License as published by the Free Software Foundation, either version 3
of the License, or (at your option) any later version.

%_MSMstructure is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for  more details.
 
You should have received a copy of the GNU General Public License along with %_MSMstructure.  
If not, see <http://www.gnu.org/licenses/>.

***********************************************************************************************/


/********* MSM Macro 0 - saving max interval count **************
* Step 1.5 of macro creation (but macro 0 because it will 	*
*				be called in Macro 1)		*
*	- to keep track of max number of intervals generated	*
* Input data:							*
*	takes in a dataset with intervals created for each	*
*	patient and a count of intervals			*
* Output:							*
*	outputs a number that reflects the max number of 	*
*	intervals created out total persons			*
****************************************************************/

%macro _maxintcnt(_idmaxintcnt,_ident,_intstart);

proc sort data=&_idmaxintcnt out=_maxdata; 
	by &_ident &_intstart; 
run;

data _maxdata;
	set _maxdata;
		by &_ident &_intstart;			*to recurse and count number of intervals, but using &_intnum;
	if first.&_ident then _intcnt=0;
	_intcnt+1; output;
run;

proc sql noprint;
      		select max(_intcnt)
	  	into :_maxintcnt
	  	from _maxdata;
quit;  
%put &_maxintcnt;
proc datasets library = work nolist;
	        delete _maxdata;
        quit;
%mend _maxintcnt;
