/***********************************************************************************************

Authors: Thomas K Leong, Grace H Tabada, Jingrong Yang, Zheng Zhu, Romain Neugebauer
Maintainer: Romain Neugebauer (romain.s.neugebauer@kp.org)

Copyright 2016 Thomas K Leong, Grace H Tabada, Jingrong Yang, Zheng Zhu, Romain Neugebauer

This file is part of %_MSMstructure.

%_MSMstructure is free software: you can redistribute it and/or modify it under the terms of 
the GNU General Public License as published by the Free Software Foundation, either version 3
of the License, or (at your option) any later version.

%_MSMstructure is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for  more details.
 
You should have received a copy of the GNU General Public License along with %_MSMstructure.  
If not, see <http://www.gnu.org/licenses/>.

***********************************************************************************************/


%macro _nobs_msm(_nobs_dsn,test=N);                                     
%*---------------------------------------------------------------------;
%*                                                                     ;
%* NOBS     This macro returns the number of observations in a SAS     ;
%*          dataset (&dsn). The number of observations is saved in the ;
%*          global macro variable &nobs.  ONLY for DASD SAS datasets!!!;
%*                                                                     ;
%*                                                                     ;
%*---------------------------------------------------------------------;
%global _nobs;                                                          
                                                                        
%let _nobs=0;                                                           
%if %length(_nobs_dsn) = 0 %then %let _nobs_dsn=_LAST_;                 
OPTIONS NODSNFERR;                                                      
RUN;                                                                    
                                                                        
DATA _NULL_;                                                            
  IF 0 THEN SET &_nobs_dsn                                              
  %if %substr(&sysver,1,1) = 5 %then                                    
                     _POINT=_N_;                                        
                NOBS=_NOBS;                                             
  CALL SYMPUT('_nobs',TRIM(LEFT(PUT(_NOBS,8.))));                       
  STOP;                                                                 
RUN;                                                                    
                                                                        
OPTIONS DSNFERR;        /* Return to this site's SAS system default. */ 
RUN;                                                                    
                                                                        
%if %upcase(%substr(&test,1,1)) = Y or                                  
    &sysenv = FORE %then %do;                                           
      %put %str( );                                                     
      %put There are &_nobs observations in data set &_nobs_dsn;        
      %put %str( );                                                     
%end;                                                                   
                                                                        
%mend _nobs_msm;                                                        
